######################################################################
#                      Inicio de detector_TC.sh                      #
######################################################################


log "INICIALIZANDO DETECTOR" "TI"

echo "Fichero;Linea;Regla;Subregla" >> $INFORME_DET
echo "Fichero;Linea;Regla;Regla Reporte;Incidencia" >> $REPORTE

awk -b -v reporte=$REPORTE -v informe_det=$INFORME_DET -v fich_log=$LOG -v reglas="${regla[*]}" -v num_reg_rep=$NUM_REG_REP '
######################################################################
#                   Nombre función: log_awk                          #
#     Descripción: imprime la cadena que recibe en el fichero        #
#       correspondiente según el nivel del texto a imprimir          #
#     Argumentos: texto --> cadena a imprimir                        #
#                 nivel --> Nivel del texto                          #
#                      I --> Información en log                      #
#                      TI -> Información en terminal e log           #
#                      ID -> Arreglos en informe_detector.csv        #
#                      R --> Reporte generado por regla              #
######################################################################
function log_awk(texto,nivel)
{
	if (nivel == "I") {
		# Pinta en log_TC.txt
		print "[INFO] ---- " texto >> fich_log
	} else if (nivel == "TI") {
		# Pinta en log_TC.txt y en el terminal
		print "[INFO] ---- " texto >> fich_log
		print "[INFO] ---- " texto
	} else if (nivel == "E") {
		# Pinta en log_TC.txt y en el terminal
		print "[ERROR]" texto >> fich_log
		print "[ERROR]" texto
		exit 1
	} else if (nivel == "D") {
		# Pinta en informe_detector_TC.csv
		print texto >> informe_det
	} else if (nivel == "R") {
		# Pinta en reportes_TC.csv
		if (texto ~ /^[^;]+;[^;]+;[^;]+;1;$/) {
			texto=texto ""
		}
		print texto >> reporte
	}
}


BEGIN{
	# Las reglas a 1 y 0 están en regla
	n_reglas=split(reglas,regla," ")

	# Inicializamos el array con lo errores de cada regla
	for (i in regla) {
		n_errores[i]=0
	}
	n_errores_totales=0
}{
	
	##################################################################
	#                            REGLA 1                             #
	##################################################################
	if (regla[1] == 1) {
		
	}
	
	##################################################################
	#                            REGLA 2                             #
	##################################################################
	if (regla[2] == 1) {
		
	}
	
}
END {
	log_awk("Estadísticas de detección","TI")
	for (i=1; i <= n_reglas; i++) {
		if (regla[i] == 1) {
			if (i <= n_reglas-num_reg_rep) {
				log_awk("Nº errores regla " i ": " n_errores[i],"TI")
			} else {
				log_awk("Nº reportes regla " i ": " n_errores[i],"TI")
			}
			n_errores_totales+=n_errores[i]
		}
	}
	log_awk("Nº errores totales: " n_errores_totales,"TI")
	
}' $WORKSHOP

err_detector=$?
if [[ $err_detector == 0 ]]
then
	log "DETECTOR FINALIZÓ SIN INCIDENCIAS" "TI"
else
	log "016 DETECTOR NO FINALIZÓ CORRECTAMENTE" "E"
fi

